Bug 851820 - (mingw-eigen3) Review Request: mingw-eigen3 - MinGW lightweight C++ template library for vector and matrix math
Review Request: mingw-eigen3 - MinGW lightweight C++ template library for vec...
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Thomas Sailer
Fedora Extras Quality Assurance
Depends On:
  Show dependency treegraph
Reported: 2012-08-25 20:24 EDT by Thomas Sailer
Modified: 2013-03-14 20:09 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2013-03-14 20:07:35 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
t.sailer: fedora‑review+
limburgher: fedora‑cvs+

Attachments (Terms of Use)

  None (edit)
Description Thomas Sailer 2012-08-25 20:24:55 EDT
Spec URL: http://sailer.fedorapeople.org/mingw-eigen3.spec
SRPM URL: http://sailer.fedorapeople.org/mingw-eigen3-3.0.4-1.fc17.src.rpm
MinGW lightweight C++ template library for vector and matrix math

Approved MinGW packaging guidelines are here:
Comment 1 Sandro Mani 2013-02-28 18:02:50 EST
Are you still pursuing this review? I'd also be interested in having this in the repos and could do a review.
Comment 2 Thomas Sailer 2013-02-28 18:08:29 EST
Yes please! Thanks
Comment 3 Sandro Mani 2013-03-01 17:32:08 EST
I've uploaded a proposed SPEC+SRPM which takes into consideration the below remarks here:
SPEC: http://smani.fedorapeople.org/mingw-eigen3.spec
SRPM: http://smani.fedorapeople.org/mingw-eigen3-3.1.2-1.fc19.src.rpm

Needs work:
- Version 3.1.2 is out (also reported for the eigen3 package, see bug #917145)
- Now mainly MPL2 licensed, plus portions BSD and GPL2 licensed
   * Change License to "MPL2 and LGPLv2+ and BSD"
   * Adjust %doc accordingly
- Unused BuildRequires (documentation is not built, and due to the unit tests which cannot be run in a cross-compile environment)
- BuildRoot is not necessary anymore
   * See http://fedoraproject.org/wiki/Packaging:Guidelines#BuildRoot_tag
- %clean section not necessary anymore
   * See http://fedoraproject.org/wiki/Packaging:Guidelines#.25clean
- %defattr is not necessary anymore
   * See http://fedoraproject.org/wiki/Packaging:Guidelines#File_Permissions
- Package does not build, since BuildRequires references non-existing packages
   * Since the mingw package only contains the headers 
- Running Eigen's unit tests does not work in a cross-compiling environment
  (since the resulting binaries are windows ones and cannot be executed)
   * You either need to preset some variables to make cmake ignore the fact that
     it cannot run binaries (see the TryRunResults.cmake in the SRPM I linked
     above), and a hack is also necessary for it to stop throwing an error
     because it could not determine the windows OS version. All this simply to 
     get cmake to do the initial configuration. cmake is actually only useful 
     for generating the pkgconfig file.
   * Or you could choose to not use cmake at all, and instead simply copy the
     headers and generate the pkg-config with sed (possibly a little less
     elegant? Though the first approach is also ugly enough :) )
- You don't need %{?mingw_debug_package}, since there is no debug info to be
  provided (only headers are installed)

- Is there a particular reason you move the pc files from share/pkgconfig to lib/pkgconfig? AFAIK both are ok (pkgconfig works also in share/pkgconfig)
- Should you Require: pkgconfig ? some packages do, i.e. glew
Comment 4 Thomas Sailer 2013-03-02 04:02:23 EST
Since you've done everything, I suggest we reverse roles.

Adding the pkgconfig dependency might be a good idea, but up to you.

scratch build is here:

+ OK
! Needs to be looked into
/ Not applicable
* Overridden by MinGW guidelines

$ rpmlint mingw-eigen3.spec mingw-eigen3-3.1.2-1.fc19.src.rpm mingw32-eigen3-3.1.2-1.fc19.noarch.rpm mingw64-eigen3-3.1.2-1.fc19.noarch.rpm
mingw-eigen3.spec: W: invalid-url Source0: eigen-3.1.2.tar.bz2
mingw-eigen3.src: W: invalid-license MPL2
mingw-eigen3.src: W: invalid-url Source0: eigen-3.1.2.tar.bz2
mingw32-eigen3.noarch: W: invalid-license MPL2
mingw32-eigen3.noarch: E: zero-length /usr/i686-w64-mingw32/sys-root/mingw/include/eigen3/Eigen/src/SparseCore/SparseAssign.h
mingw64-eigen3.noarch: W: invalid-license MPL2
mingw64-eigen3.noarch: E: zero-length /usr/x86_64-w64-mingw32/sys-root/mingw/include/eigen3/Eigen/src/SparseCore/SparseAssign.h
3 packages and 1 specfiles checked; 2 errors, 5 warnings.

[!] MPL2 should be replaced by MPLv2.0 (see http://fedoraproject.org/wiki/Licensing:Main#Good_Licenses)
[!] SparseAssign.h should IMO be removed, it does not seem to serve any purpose, has never been non-zero in upstream hg repository, and has since been removed
The invalid-url warning can be ignored (native eigen3) does the same thing. You might however update the version number in the # Source file comment.

[+] Files are installed in /usr/i686-w64-mingw32/sys-root/mingw, /usr/x86_64-w64-mingw32/sys-root/mingw/
[+] BuildRequires: mingw32-filesystem, mingw64-filesystem is in the .spec file
[+] Requires are OK
[+] BuildArch: noarch
[+] No man pages or info files
[+] default strip and objdump commands are overridden with mingw specific ones

[+] rpmlint must be run on every package. The output should be posted in the review
[+] MUST: The package must be named according to the Package Naming Guidelines
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption on Package Naming Guidelines
[+] MUST: The package must meet the Packaging Guidelines
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
[!] MUST: The License field in the package spec file must match the actual license. See above, the correct tag would be MPLv2.0
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL.
$ md5sum eigen-3.1.2.tar.bz2 3.1.2.tar.bz2 
e9c081360dde5e7dcb8eba3c8430fde2  eigen-3.1.2.tar.bz2
e9c081360dde5e7dcb8eba3c8430fde2  3.1.2.tar.bz2
[+] MUST: The package must successfully compile and build into binary rpms on at least one supported architecture.
[+] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch.
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines; inclusion of those as BuildRequires is optional.
[/] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[*] MUST: Every binary RPM package which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. 
[/] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package.
[+] MUST: A package must own all directories that it creates. 
[+] MUST: A package must not contain any duplicate files in the %files listing.
[+] MUST: Permissions on files must be set properly.
[+] MUST: Each package must consistently use macros, as described in the macros section of Packaging Guidelines .
[+] MUST: The package must contain code, or permissable content.
[/] MUST: Large documentation files should go in a -doc subpackage.
[/] MUST: If a package includes something as %doc, it must not affect the runtime of the application.
[*] MUST: Header files must be in a -devel package.
[+] MUST: Static libraries must be in a -static package.
[/] MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).
[*] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
[*] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}
[*] MUST: Packages must NOT contain any .la libtool archives, these should be removed in the spec.
[/] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section.
[+] MUST: Packages must not own files or directories already owned by other packages.
[+] MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} ( or $RPM_BUILD_ROOT ). See Prepping BuildRoot For %install for details.
[+] MUST: All filenames in rpm packages must be valid UTF-8.
[/] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[/] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock. See MockTricks for details on how to do this.
[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[/] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[/] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[+] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[/] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg.
[/] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
Comment 5 Thomas Sailer 2013-03-02 04:12:44 EST
SparseAssign.h is included in Eigen/SparseCore, so it needs to be removed there as well
Comment 6 Sandro Mani 2013-03-02 20:47:52 EST
SPEC: http://smani.fedorapeople.org/mingw-eigen3.spec
SRPM: http://smani.fedorapeople.org/mingw-eigen3-3.1.2-2.fc19.src.rpm

* Sun Mar 03 2013 Sandro Mani <manisandro@gmail.com> - 3.1.2-2
- Fix license

As for the SparseAssign.h, since it does no harm, I'd rather keep as close to the upstream release as possible.
Comment 7 Thomas Sailer 2013-03-03 00:00:43 EST
The empty SparseAssign.h is in the native package as well, so I agree to keep it as is.

However, rpmlint still complains about the license:
$ rpmlint mingw-eigen3-3.1.2-2.fc19.src.rpm 
mingw-eigen3.src: W: invalid-license MPLv2

According to the licensing wiki page, there's no such thing as "MPLv2", you really need to use "MPLv2.0". When that is fixed, I'll approve...
Comment 8 Sandro Mani 2013-03-03 06:36:01 EST
SPEC: http://smani.fedorapeople.org/mingw-eigen3.spec
SRPM: http://smani.fedorapeople.org/mingw-eigen3-3.1.2-2.fc19.src.rpm

Argh, late night work... License is now correct.
Comment 9 Thomas Sailer 2013-03-03 07:22:22 EST
All ok now.


 The package mingw-eigen3 is APPROVED by sailer

Comment 10 Sandro Mani 2013-03-03 13:22:46 EST
New Package SCM Request
Package Name: mingw-eigen3
Short Description: MinGW build of the eigen C++ template library
Owners: smani
Branches: f17 f18
Comment 11 Gwyn Ciesla 2013-03-04 08:35:44 EST
Git done (by process-git-requests).
Comment 12 Fedora Update System 2013-03-05 16:17:52 EST
mingw-eigen3-3.1.2-1.fc18 has been submitted as an update for Fedora 18.
Comment 13 Fedora Update System 2013-03-05 16:29:08 EST
mingw-eigen3-3.1.2-1.fc17 has been submitted as an update for Fedora 17.
Comment 14 Fedora Update System 2013-03-06 17:57:19 EST
mingw-eigen3-3.1.2-1.fc18 has been pushed to the Fedora 18 testing repository.
Comment 15 Fedora Update System 2013-03-14 20:07:36 EDT
mingw-eigen3-3.1.2-1.fc17 has been pushed to the Fedora 17 stable repository.
Comment 16 Fedora Update System 2013-03-14 20:09:08 EDT
mingw-eigen3-3.1.2-1.fc18 has been pushed to the Fedora 18 stable repository.

Note You need to log in before you can comment on or make changes to this bug.